library ieee;
use ieee.std_logic_1164.all;
--Left to Right Shift Register with parallel Load and Enable
entity shiftrne is
GENERIC(N : integer := 4);
port(data : in std_logic_vector(N-1 downto 0);
	 Load : in std_logic;
	 Enable : in std_logic;
	 Clk : in std_logic;
	 q : buffer std_logic_vector(N-1 downto 0)
	);
end shiftrne;

architecture rtl of shiftrne is
begin
  process
  begin
    wait until clk'EVENT and clk = '1' ;
	if (enable = '1') then
	  if Load = '1' then  
		q <= data;
	  else	
		  --Left to Right	
		  L_Genbits: for i in 0 to N-2 loop
		    		   q(i) <= q(i+1);
  			         end loop;
	    		     q(n-1) <= q(0); 
	  end if;
	end if;
  end process;
end rtl;
  
