library ieee;
use ieee.std_logic_1164.all;
entity BCD_7 is
port(
	i : in integer range 0 to 9;
	o : out std_logic_vector(6 downto 0);
	ca : out std_logic_vector(3 downto 0)
	);
end BCD_7;
architecture RTL of BCD_7 is
begin
  ca <= "1110";	
  process(i)
  begin
	case i is
	  when 0 =>
		o <= "1000000";
	  when 1 =>
		o <= "1111001";
	  when 2 =>
		o <= "0100100";
	  when 3 =>
		o <= "0110000";
	  when 4 =>
		o <= "0011001";
	  when 5 =>
		o <= "0010010";
	  when 6 =>
		o <= "0000011";
	  when 7 =>
		o <= "1111000";
	  when 8 =>
		o <= "0000000";
	  when 9 =>
		o <= "0011000";
	end case;
  end process;
end RTL;

		
